$(function() {
    $("#dropzone").on("dragenter", highlight);
    $("#dropzone").on("dragover", highlight);
    $("#dropzone").on("dragleave", unhighlight);
    $("#dropzone").on("drop", handleDrop);

/*
    ;['dragenter', 'dragover'].forEach(eventName => {
          dropArea.addEventListener(eventName, highlight, false)
    })

    ;['dragleave', 'drop'].forEach(eventName => {
          dropArea.addEventListener(eventName, unhighlight, false)
    })

    function highlight(e) {
          dropArea.classList.add('highlight')
    }

    function unhighlight(e) {
          dropArea.classList.remove('highlight')
    }
    */
});

function highlight(e) {
    e.preventDefault();
    e.stopPropagation();
    $("#dropzone").addClass("drop-active");
}

function unhighlight(e) {
    e.preventDefault();
    e.stopPropagation();
    $("#dropzone").removeClass("drop-active");
}

function handleDrop(e) {
    e.preventDefault();
    e.stopPropagation();
    ([...e.originalEvent.dataTransfer.files]).forEach(uploadFile);
}

function uploadFile(file) {
    $("#dropzone").addClass("drop-uploading");
    let formData = new FormData();

    formData.append('document', file)
    fetch("/", {
        method: 'POST',
        body: formData
    })
    .then(function() { info("File " + file.name + " sent to printer."); })
    .catch(function() { error("An error occured while sending " + file.name + " to printer.") })

}

function info(text) {
  $("#dropzone").removeClass("drop-uploading");
  $("#dropzone").removeClass("drop-active");
  $("#messages").append('<div class="alert alert-success">' + text + "</div>");
  setTimeout(clear, 3000);
}

function error(text) {
  $("#dropzone").removeClass("drop-uploading");
  $("#dropzone").removeClass("drop-active");
  $("#messages").append('<div class="alert alert-danger">' + text + "</div>");
  setTimeout(clear, 3000);
}

function clear() {
  $("#messages").empty();
}
